/* tslint:disable */
/* eslint-disable */
/**
* @param {number} w
* @param {Uint8Array} board
* @param {number} min
* @returns {number}
*/
export function find_winner(w: number, board: Uint8Array, min: number): number;
/**
* @param {Uint8Array} board
* @returns {number}
*/
export function count_empty(board: Uint8Array): number;
/**
* @param {number} me
* @param {number} other
* @param {boolean} first
* @param {number} empty
* @returns {number}
*/
export function get_turn(me: number, other: number, first: boolean, empty: number): number;
/**
* @param {number} me
* @param {number} other
* @param {boolean} first
* @param {number} w
* @param {Uint8Array} board
* @param {number} min
* @returns {number}
*/
export function mm_get_score(me: number, other: number, first: boolean, w: number, board: Uint8Array, min: number): number;
/**
* @param {number} me
* @param {number} other
* @param {boolean} first
* @param {number} w
* @param {Uint8Array} board
* @param {number} min
* @returns {number}
*/
export function mm_d_get_score(me: number, other: number, first: boolean, w: number, board: Uint8Array, min: number): number;
/**
* @param {number} me
* @param {number} other
* @param {boolean} first
* @param {number} w
* @param {Uint8Array} board
* @param {number} min
* @param {string} algorithm
* @returns {number}
*/
export function get_score(me: number, other: number, first: boolean, w: number, board: Uint8Array, min: number, algorithm: string): number;
/**
* @param {number} me
* @param {number} other
* @param {boolean} first
* @param {number} w
* @param {Uint8Array} board
* @param {number} min
* @param {string} algorithm
* @returns {number}
*/
export function predict(me: number, other: number, first: boolean, w: number, board: Uint8Array, min: number, algorithm: string): number;

export type InitInput = RequestInfo | URL | Response | BufferSource | WebAssembly.Module;

export interface InitOutput {
  readonly memory: WebAssembly.Memory;
  readonly find_winner: (a: number, b: number, c: number, d: number) => number;
  readonly count_empty: (a: number, b: number) => number;
  readonly get_turn: (a: number, b: number, c: number, d: number) => number;
  readonly mm_get_score: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => number;
  readonly mm_d_get_score: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => number;
  readonly get_score: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number) => number;
  readonly predict: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number) => number;
  readonly __wbindgen_malloc: (a: number) => number;
  readonly __wbindgen_realloc: (a: number, b: number, c: number) => number;
}

/**
* Synchronously compiles the given `bytes` and instantiates the WebAssembly module.
*
* @param {BufferSource} bytes
*
* @returns {InitOutput}
*/
export function initSync(bytes: BufferSource): InitOutput;

/**
* If `module_or_path` is {RequestInfo} or {URL}, makes a request and
* for everything else, calls `WebAssembly.instantiate` directly.
*
* @param {InitInput | Promise<InitInput>} module_or_path
*
* @returns {Promise<InitOutput>}
*/
export default function init (module_or_path?: InitInput | Promise<InitInput>): Promise<InitOutput>;
